class MERCostReport(PWReportPage):
	def init(self):
		super(MERCostReport, self).init()
		self.project				= None
		self.withObjective			= True
		self.withAssignments        = True
		self.withActual				= True
		self.withExpected			= True
		self.withPlanned			= True
		self.withBudget             = False
		self.showLevel				= 3
		self.withRemaining			= True
		self.iterIndex				= 0
		self.iterTask               = None

		return self

		
	def showObjective(self):
		return self.project.itemDescription()

	def addActivitiesAndChildActivitiesDeep(self, activities, result):
		if activities:
			for aAct in activities:
				if aAct.level() <= self.showLevel:
					if self.withAssignments:
						result.append(aAct)
					else:
						if aAct.isAssignment() == 0:
							result.append(aAct)
					self.addActivitiesAndChildActivitiesDeep(aAct.visibleSubActivitiesArray(), result)
		return	

	def getActsWithGroups(self):
		result = []
		activities = self.project.visibleSubActivitiesArray()
		if activities:
			startDateDescriptor = NSSortDescriptor.alloc().initWithKey_ascending_("flatOrder", True)
			self.addActivitiesAndChildActivitiesDeep(activities, result)	
			return NSArray.arrayWithArray_(result).sortedArrayUsingDescriptors_([startDateDescriptor])
		else:
			return NSArray.array()

	def spaceByLevel(self):
		many = self.iterTask.level()		
		return many*15

				
	def rowClass(self):
		if self.iterIndex%2:
			return "even"

	def totalRowClass(self):
		if len(self.getActsWithGroups())%2:
			return "even"
		
	def dateFormat(self):
		return "medium/short"


	def cellClassForAmount(self, amount):
		if amount < 0:
			return "negativeBalance"
		else:
			return "positiveBalance"

	def expectedBalanceCellClass(self):
		return self.cellClassForAmount(self.iterTask.budgetExpectedCostBalance())

	def actualBalanceCellClass(self):
		return self.cellClassForAmount(self.iterTask.budgetActualCostBalance())

	def expectedProjectBalanceCellClass(self):
		return self.cellClassForAmount(self.project.budgetExpectedCostBalance())

	def actualProjectBalanceCellClass(self):
		return self.cellClassForAmount(self.project.budgetActualCostBalance())

	
	def remainingCosts(self):
		if self.iterTask != None:
			expected = self.iterTask.expectedCost()
			actual = self.iterTask.actualCost()
		else:
			expected = self.project.expectedCost()
			actual = self.project.actualCost()	
		if actual != None:
			return expected - actual
		else:
			return expected
	





